public class DatenGA implements IDatenGA {
 
  private int[] massen;
  private int[] werte;
  private int maxMasse;
  private int codelnge;

  public DatenGA (int c) {
    codelnge = c;
    massen = new int[codelnge];
    werte = new int[codelnge];
    int massensumme = 0;
    for (int k = 0; k < codelnge; k++) {
      int m = (int) Math.random() * codelnge + 1;
      massen[k] = m;
      massensumme += m;
      int w = (int) Math.random() * codelnge + 1;
      werte[k] = w;
      } // Ende for
    maxMasse = (int) (0.75 *massensumme);
    } // Ende Konstruktor

  public int fitnesswert (Individuum genCode){
    int wert = 0;
    int masse = 0;
    for (int k = 0; k < codelnge; k++) {
      if (genCode.getGen(k) == 1) {
        wert = wert + werte[k];
        masse = masse + massen[k];
        } // Ende if
      } // Ende for
    if (masse > maxMasse)
      wert = 0;
    return wert;
    } // Ende fotnesswert
    
  public boolean istBesser (Individuum c1, Individuum c2)
    {return fitnesswert(c1) >= fitnesswert(c2);}
    
  public String toString() {
    String s = "";
    for (int k = 0; k < codelnge; k++)
      s = s + k + " Masse = " + massen[k] 
            + " Wert = " + werte[k] + "\n";
    s = s + "Maximale Masse = " + maxMasse + "\n";
    return s;
    } // Ende toString
    
  public Paar kreuzung (Individuum c1, Individuum c2) {
    int codelnge = c1.getCodelnge();
    int stelle = (int) Math.random() * codelnge + 1;
    Individuum i1 = new Individuum(codelnge);
    Individuum i2 = new Individuum(codelnge);
    for (int k = 0; k < stelle; k++) {
      i1.setGen(k, c1.getGen(k));
      i2.setGen(k, c2.getGen(k));
      } // Ende for
    for (int k = stelle; k < codelnge; k++) {
      i1.setGen(k, c2.getGen(k));
      i2.setGen(k, c1.getGen(k));
      } // Ende for
    return new Paar(i1,i2);
    } // Ende for

  public void mutiere (Individuum c) {
    int pos = (int) Math.random() * c.getCodelnge();
    if (c.getGen(pos) == 1) 
      c.setGen(pos, 0);
    else 
      c.setGen(pos,1);
    } // Ende mutiere
    
  public void initZufllig (Individuum c) {
    for (int j = 0; j < c.getCodelnge(); j++) {
      if (Math.random() < 0.5)
        c.setGen(j,1);
      else 
        c.setGen(j,0);
      } // Ende for
    } // Ende initZufllig
 
  public int getMaxMasse()
    {return maxMasse;}
 
  public int getMasse (Individuum genCode) {
    int masse = 0;
    for (int k = 0; k < codelnge; k++) {
      if (genCode.getGen(k) == 1)
        masse = masse + massen[k];
      } // Ende ffor
    return masse;
    } // Ende getMasse
    
  } // Ende DatenGA

