import java.awt.*;
import java.util.*;

public class Sicht1 extends Canvas
                    implements Observer {

  private Population population;
  private IDatenGA   basis;

  public Sicht1 (Population p) {
    population = p;
    basis = population.getGrunddaten();
    population.addObserver(this);
    setBackground(Color.pink);
    } // Ende Konstruktor

  public void paint (Graphics g) {
    Rectangle r = this.getBounds();
    g.setColor(Color.blue); 
    g.drawString("Wert = f(Nummer des Individuums)", 40, 20);

    int breite = r.width - 12; 
    int hhe = r.height - 4;
    int maxX = population.getIndividuenzahl();
    int c = population.getCodelnge();   
    int maxY = c * c;
    double dx = (double) breite / (double) maxX;
    double dy = (double) hhe / (double) maxY;
    double deltaY = maxY / 10.0;
    int x = 0;  int y = 0;
    while (y <= maxY) {
      g.drawString(Integer.toString(y), 0, hhe - (int) (y * dy));
      y += deltaY;
      } // Ende while
    for (int k = 0; k < maxX; k++) {
      Individuum ind = population.getIndividuum(k);
      x = (int) (dx * k);
      y = (int) (dy * basis.fitnesswert(ind));
      g.fillOval(x + 20, hhe - y - 4, 4, 4);
      } // Ende for
    int best = basis.fitnesswert(population.bestes());
    int bestPos = hhe - 4 - (int)(dy * best);
    g.setColor(Color.red);  
    g.drawLine(12, bestPos, breite + 4, bestPos);
    g.drawString("Maximaler Wert = " + best, 40, 40);
    } // Ende paint

  public void update (Observable o, Object obj)
    {repaint();}

  } // Ende Sicht1

